--- src/Fl_Browser_.cxx
+++ src/Fl_Browser_.cxx
@@ -566,11 +566,15 @@
       } else switch (Fl::event_key()) {
       case FL_Enter:
       case FL_KP_Enter:
-	select_only(l, 1);
+	select_only(l, when() & (~FL_WHEN_ENTER_KEY)); //(no callback for changes here, if when()==FL_WHEN_ENTER_KEY)
+	if (when() & FL_WHEN_ENTER_KEY) { //(but do one callback here)
+          set_changed();
+          do_callback();
+        }
 	return 1;
       case ' ':
 	selection_ = l;
-	select(l, !item_selected(l), 1);
+	select(l, !item_selected(l), when() & (~FL_WHEN_ENTER_KEY)); //(no callback for changes here)
 	return 1;
       case FL_Down:
 	while ((l = item_next(l))) {
@@ -736,6 +740,12 @@
       if (when() & FL_WHEN_RELEASE) do_callback();
     } else {
       if (when() & FL_WHEN_NOT_CHANGED) do_callback();
+    }
+    
+    // double click calls the callback: (like Enter Key)
+    if (Fl::event_clicks() && (when() & FL_WHEN_ENTER_KEY)) {
+      set_changed();
+      do_callback();
     }
     return 1;
   case FL_FOCUS:
